'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _details = require('./popUp/details');

var _details2 = _interopRequireDefault(_details);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var indicatorSize = 30;

function tap(obj) {
  var el = obj;
  var reveal = true;
  var shrink = false;
  var opacity = 0;
  var scale = 1;
  var shadow = 0;
  setInterval(function () {
    if (reveal) {
      if (opacity >= 1) {
        setTimeout(function () {
          reveal = false;
          shrink = true;
        }, 500);
      } else {
        opacity += 0.008;
        el.style.opacity = '' + opacity;
      }
    } else if (shrink) {
      if (scale <= 0.9) {
        setTimeout(function () {
          shrink = false;
        }, 0);
      } else {
        scale -= 0.01;
        el.style.transform = 'scale(' + scale + ', ' + scale + ')';
      }
    } else {
      if (opacity <= 0) {
        setTimeout(function () {
          reveal = true;
          scale = 1;
          shadow = 0;
          el.style.boxShadow = '0 0 6px ' + shadow + 'px #CCCCCC';
          el.style.transform = 'scale(' + scale + ', ' + scale + ')';
        }, 250);
      } else {
        opacity -= 0.009;
        shadow += 0.1;
        el.style.opacity = '' + opacity;
        el.style.boxShadow = '0 0 6px ' + shadow + 'px #CCCCCC';
      }
    }
  }, 10);
  return el;
}

function styleIndicator(parent, obj) {
  var el = obj;
  el.style.position = 'absolute';
  el.style.zIndex = '99999999999999999';
  el.style.height = indicatorSize + 'px';
  el.style.width = indicatorSize + 'px';
  el.style.opacity = '1';
  el.style.backgroundColor = 'rgba(204, 204, 204, 0.6)';
  el.style.border = 'solid 2px rgba(204, 204, 204, 1)';
  el.style.borderRadius = '50%';
  el.style.cursor = 'pointer';
  el.style.left = '-15px';
  el.style.top = '60%';
  return el;
}

function animate(obj) {
  var el = obj;
  el = window.logixTourConfig.tap ? tap(el) : el;
  return el;
}

function create(tourGuide, title, prefix) {
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = tourGuide[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var guide = _step.value;

      var indicator = document.createElement('div');
      indicator = styleIndicator(guide.el, indicator);
      indicator = (0, _details2.default)(guide.el, indicator, title);
      indicator = animate(indicator);
      indicator.className = prefix + '-logix-tour-indicator tour-active';
      guide.el.parentNode.insertBefore(indicator, guide.el.nextSibling);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }
}

exports.default = create;