'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = addEvent;

var _quadrant = require('./../quadrant');

var _quadrant2 = _interopRequireDefault(_quadrant);

var _buildStuff = require('./buildStuff');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function stylePopUp(parent, obj) {
  var el = obj;
  var parentBounds = parent.getBoundingClientRect();
  var elBounds = el.getBoundingClientRect();
  var quad = (0, _quadrant2.default)(parent);
  var top = parentBounds.top - elBounds.height / 2;
  var left = 0;
  if (quad === 1 || quad === 3) {
    if (parentBounds.top < 50) {
      top = parentBounds.top + elBounds.height / 2;
    }
    left = parentBounds.left + 40;
  } else if (quad === 2 || quad === 4) {
    if (window.innerHeight - parentBounds.bottom < 50) {
      top = parentBounds.top - elBounds.height * 1.5;
    }
    left = parentBounds.left - elBounds.width - 10;
  }
  el.style.position = 'absolute';
  el.style.border = 'solid 2px #D8D8D8';
  el.style.borderRadius = '5px';
  el.style.backgroundColor = 'whitesmoke';
  el.style.boxShadow = '0 0 1px 5000px rgba(0, 0, 0, 0.4)';
  el.style.padding = '15px 10px';
  el.style.zIndex = '99999999';
  el.style.top = top + 'px';
  el.style.left = left + 'px';
  return el;
}

function removePopUp() {
  var otherPopUps = document.getElementById('logix-tour-popup');
  if (otherPopUps) window.logixTourConfig.appendTarget.removeChild(otherPopUps);
}

function removePopUpAndClear(el, cb) {
  var otherPopUps = document.getElementById('logix-tour-popup');
  if (otherPopUps) otherPopUps.parentNode.removeChild(otherPopUps);
  try {
    el.parentNode.removeChild(el);
  } catch (err) {
    // DON'T WORRY ABOUT THROWING THIS
  }
  cb();
}

function addEvent(parent, el, title) {
  var _this = this;

  var text = parent.dataset.tourText || 'Now that I have your attention!';
  el.addEventListener('click', function (e) {
    removePopUp();
    var popUp = document.createElement('div');
    popUp.id = 'logix-tour-popup';
    (0, _buildStuff.buildTitle)(popUp, title);
    (0, _buildStuff.buildContent)(popUp, text);
    (0, _buildStuff.buildDismiss)(popUp);
    window.logixTourConfig.appendTarget.appendChild(popUp);
    popUp.style.width = '250px';
    popUp.style.minHeight = '50px';
    popUp = stylePopUp(el, popUp);
    var removeThisPopUp = removePopUpAndClear.bind(_this, el, function () {
      document.removeEventListener('click', removeThisPopUp);
      if (window.logixTourConfig.onClose) {
        window.logixTourConfig.onClose(parent);
      }
    });
    document.addEventListener('click', removeThisPopUp);
    e.stopPropagation();
  });
  return el;
}